#ifndef FSMDETERMINIZER_H_
#define FSMDETERMINIZER_H_

#include <string>
#include <set>
#include <map>

#include "automaton/State.h"
#include "DeterminizationUtils.h"
#include "automaton/FSM/FSM.h"
#include "automaton/FSM/TransitionFSM.h"

using namespace std;
using namespace automaton;

namespace determinization {

class FSMDeterminizer {
protected:
    FSM* nondeterministicFSM;
    FSM* deterministicFSM;
    
    set<State> findToStates(const set<State>& nfsmStates, const Symbol& input);
    
public:
    FSMDeterminizer(FSM* automaton);
    FSM* determinize();
    
};

} /* namespace determinization */
#endif /* FSMDETERMINIZER_H_ */