#ifndef RHDPDADETERMINIZATIONUTILS_H_
#define RHDPDADETERMINIZATIONUTILS_H_

#include <string>
#include <set>
#include <map>
#include <vector>

#include "automaton/PDA/PDA.h"
#include "automaton/Transition.h"
#include "automaton/exception/AutomatonException.h"
#include "alphabet/Symbol.h"
#include "DeterminizationUtils.h"
#include "RHDPDADeterminizationUtils.h"
#include "RHDPDADeterminizationStructs.h"

using namespace std;
using namespace automaton;
using namespace alphabet;

namespace determinization {

class RHDPDADeterminizationUtils {
public:
    static const Symbol BOTTOM_OF_STACK_SYMBOL;

    static string buildPairName(const StateSymbolPair& pair);
    static string buildStateName(const SComponent& s, const RComponent& r);
    static const State& getOrCreateState(const SComponent& s, const RComponent& r, map<string, StateData>& states,
        PDA& rdpda);
    static const SComponent getSComponentWithPairsIdentity(const set<StateSymbolPair>& pairs);
    static string buildStackSymbolName(const SComponent& s, const RComponent& r, const Symbol& input, PDA& rdpda);
    static vector<SComponent> generateAllPossibleSComponents(set<StateSymbolPair>& pairs);
    static vector<RComponent> generateAllPossibleRComponents(set<StateSymbolPair>& pairs);
    static StateData* getUnmarkedState(map<string, StateData>& states);
    static set<StateSymbolPair> combineStatesWithSymbol(const set<State>& states, const Symbol& symbol);
    static set<StateSymbolPair> buildAllStateSymbolPairs(PDA& rhdpda);
};

} /* namespace determinization */
#endif /* RHDPDADETERMINIZATIONUTILS_H_ */