#ifndef VPADETERKMINIZATIONUTILS_H_
#define VPADETERKMINIZATIONUTILS_H_

#include <math.h>
#include <string>
#include <set>
#include <map>
#include <vector>

#include "automaton/PDA/PDA.h"
#include "automaton/Transition.h"
#include "alphabet/Symbol.h"
#include "VPADeterminizationStructs.h"

using namespace automaton;
using namespace alphabet;

namespace determinization {

class VPADeterminizationUtils {
public:
    static const Symbol BOTTOM_OF_STACK_SYMBOL;

    static string buildStateName(const SComponent& s, const RComponent& r);
    static const State& getOrCreateState(const SComponent& s, const RComponent& r, map<string, StateData>& states,
        PDA& deterministicVPA);
    static const SComponent getSComponentWithStatesIdentity(const set<State>& states);
    static void divideInputAlphabet(PDA& nondeterministicVPA, set<Symbol>& internalSymbols, set<Symbol>& callSymbols,
        set<Symbol>& returnSymbols);
    static string buildStackSymbolName(const SComponent& s, const RComponent& r, const Symbol& input);
    static vector<PartialStackData> buildStackAlphabet(PDA& nondeterministicVPA, PDA& deterministicVPA,
        set<Symbol>& callSymbols);
    static StateData* getUnmarkedState(map<string, StateData>& states);

};

} /* namespace determinization */
#endif /* VPADETERKMINIZATIONUTILS_H_ */