/*
 * GrammarDiff.h
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#ifndef GRAMMAR_DIFF_H_
#define GRAMMAR_DIFF_H_

#include <ostream>

#include <grammar/UnknownGrammar.h>
#include <map>
#include <utility>

class GrammarDiff {
	static bool testDiff(const grammar::UnknownGrammar& a, const grammar::UnknownGrammar& b);
	static void printDiff(const grammar::UnknownGrammar& a, const grammar::UnknownGrammar& b);

	template <class T> static void setDiff(const std::set<T> a, const std::set<T> b);
	template <class T> static void listDiff(const std::list<T> a, const std::list<T> b);
public:
	static int diff(const grammar::UnknownGrammar& a, const grammar::UnknownGrammar& b);
};

#endif /* GRAMMAR_DIFF_H_ */
