#include <iostream>

#include <AlibException.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpParser.h>
#include <regexp/RegExpSymbol.h>
#include <sax/SaxInterface.h>

#include "RegExpIntegral.h"


using namespace alib;
using namespace regexp;
using namespace std;

/*
 * Usage:
 *  aintegral "a" "b" "cc" < regexp.xml
 */

int main(int argc, char** argv)
{
    try
    {
        list<Token> tokens;
        string input(istreambuf_iterator<char>(cin), (istreambuf_iterator<char>()));
        SaxInterface::parseMemory(input, tokens);
        RegExp re = RegExpParser::parse(tokens);

        list<RegExpElement*> dString;
        for( int i = 1; i < argc ; i++ )
        {
            string symbol( argv[ i ] );
            // cout << "'" << symbol << "'" << endl;
            if( symbol == "" )
                dString.push_back( new RegExpEpsilon( ) );
            else
                dString.push_back( new RegExpSymbol( symbol ) );
        }
        RegExpIntegral i( re );
        i.integral( dString ).toXML( cout );

        for( const auto & symbol : dString )
            delete symbol;
    }
    catch( AlibException & e )
    {
        cout << e.what() << endl;
        return 1;
    }

    return 0;
}
