/*
 * TransitionFSM.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#include "TransitionFSM.h"

namespace automaton {
TransitionFSM::TransitionFSM(const State& from,const Symbol& input,const State& to) : Transition(from, input, to) {
}

bool TransitionFSM::operator < (const TransitionFSM& other) const {
	if(from != other.from) {
		return from < other.from;
	} else if(input != other.input) {
		return input < other.input;
	} else {
		return to < other.to;
	}
}

bool TransitionFSM::operator == (const TransitionFSM& other) const {
	return from == other.from && input == other.input && to == other.to;
}

bool TransitionFSM::operator != (const TransitionFSM& other) const {
	return from != other.from || input != other.input || to != other.to;
}

std::ostream& TransitionFSM::operator>>(std::ostream& out) const {
	out << "TransitionFSM from = " << this->from
		<< " to = " << this->to
		<< " input = " << this->input;

	return out;
}

} /* namespace automaton */
