/*
 * ParseToken.h
 *
 *  Created on: 9.8.2012
 *      Author: martin
 */

#ifndef PARSETOKEN_H_
#define PARSETOKEN_H_

#include <string>

namespace sax {

using namespace std;

/**
 * Represents part of parsed XML. Can be start of tag, end of tag,
 * tag attribute or array of characters.
 */
class Token {
public:

	enum TokenType {
		START_ELEMENT, END_ELEMENT, ATTRIBUTE, CHARACTER
	};

private:
	string data;
	TokenType type;

public:
	Token(const string, const TokenType);
	virtual ~Token();

	/**
	 * @return name of the tag or characters read
	 */
	string getData() const;

	/**
	 * @return type of the token - star of the tag, end of the tag, attribute
	 * of the tag or characters
	 */
	TokenType getType() const;
};

} /* namespace sax */

#endif /* PARSETOKEN_H_ */
